library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
entity test_counter_sw is
end test_counter_sw;
architecture Behavioral of test_counter_sw is
component counter_sw is
  Port ( clk : in STD_LOGIC;
         rst : in STD_LOGIC;
         sw0 : in STD_LOGIC;
         sw1 : in STD_LOGIC;
         led : out STD_LOGIC_VECTOR (7 downto 0));
  end component;
  
  signal clk : STD_LOGIC;
  signal tb_rst : STD_LOGIC;
  signal rst : STD_LOGIC;
  signal tb_sw0 : STD_LOGIC;
  signal sw0 : STD_LOGIC;
  signal sw1 : STD_LOGIC;
  signal led : STD_LOGIC_VECTOR (7 downto 0);

begin

  dut : counter_sw port map ( --eXgΏۂ̃CX^X
    clk=>clk,
    rst=>rst,
    sw0=>sw0,
    sw1=>sw1,
    led=>led);
    
  rst <= tb_rst; --Basys3
  --rst <= not tb_rst; --DE10-lite 
  sw0 <= tb_sw0; --Basys3
  --sw0 <= not tb_sw0; --DE10-lite 
 
  process begin --NbN̐
     clk <='0';
     wait for 5ns;
     clk <='1';
     wait for 5ns;
  end process; 
    
  process begin --ZbgM
    tb_rst <='1';
	sw1 <= '1';
	tb_sw0 <= '0';
    wait for 10ns;
    tb_rst <='0';
    wait for 30000000ns;
	tb_sw0 <= '0';
    wait for 30000000ns;
	tb_sw0 <= '1';
    wait for 40000000ns;
	tb_sw0 <= '0';
    wait for 30000000ns;
	sw1 <= '0';
    wait for 30000000ns;
	tb_sw0 <= '0';
    wait for 30000000ns;
	tb_sw0 <= '1';
    wait for 50000000ns;
	tb_sw0 <= '0';
    wait for 30000000ns;
    wait;  --V~[V~
  end process;
 
end Behavioral;
