--2021.01.26 v1.00
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity sw_correction is
    Port ( clk : in STD_LOGIC;
           reset : in STD_LOGIC;
           sw_in  : in STD_LOGIC; --XCb`
           check_sig  : in STD_LOGIC; --`^O^C~O
           sw_out : out STD_LOGIC);
end sw_correction;

architecture Behavioral of sw_correction is
    signal sw_dff1 :STD_LOGIC;
    signal sw_dff2 :STD_LOGIC;
    signal sw_t1 :STD_LOGIC;
    signal sw_t2 :STD_LOGIC;
    signal sw_t3 :STD_LOGIC;
    signal sw_value :STD_LOGIC;   
begin
--^Xe[u΍
  process(clk) begin
  if clk'event and clk='1' then
    sw_dff1 <= sw_in;
    sw_dff2 <= sw_dff1;
  end if;
  end process;
--`^O@l̕ۑ
  process(clk,reset) begin
  if(reset='1') then
    sw_t1 <='0';
    sw_t2 <='0';
    sw_t3 <='0';
  else
    if clk'event and clk='1' then
      if(check_sig='1') then
        sw_t1 <=sw_dff2;
        sw_t2 <=sw_t1;
        sw_t3 <=sw_t2;
      else
        sw_t1 <=sw_t1;
	    sw_t2 <=sw_t2;
        sw_t3 <=sw_t3;
      end if;
    end if;
  end if;
  end process;
--3Alm
  process(clk,reset) begin
  if(reset='1') then
    sw_value <= '0';
  else
    if clk'event and clk='1' then
      if(check_sig='1') then
        if((sw_t1='0')and(sw_t2='0')and(sw_t3='0')) then
          sw_value <= '0';
        else 
		  if((sw_t1='1')and(sw_t2='1')and(sw_t3='1')) then
            sw_value <= '1';
          else
            sw_value <= sw_value;
		  end if;
		end if;
      else
        sw_value <= sw_value;
      end if;
	end if;
  end if;
  end process;
        
  sw_out <= sw_value;

end Behavioral;  
