`timescale 1ns / 1ps
//2021.01.26 v1.00
module sw_correction(
    input clk,
    input reset,
    input sw_in,  //XCb`
    input check_sig,//`^O^C~O
    output sw_out
    );    
    reg sw_dff1,sw_dff2;
    reg sw_t1,sw_t2,sw_t3;
    reg sw_value;   
    //^Xe[u΍
    always@(posedge clk) begin
      sw_dff1 <=sw_in;
      sw_dff2 <=sw_dff1;
    end
    //`^Oh~@l̕ۑ
    always@(posedge clk,posedge reset) begin
      if(reset==1'b1)begin
        sw_t1 <=1'b0;
        sw_t2 <=1'b0;
        sw_t3 <=1'b0;
      end
      else
        if(check_sig==1'b1)begin
          sw_t1 <=sw_dff2;
          sw_t2 <=sw_t1;
          sw_t3 <=sw_t2;
        end
        else begin
          sw_t1 <=sw_t1;
          sw_t2 <=sw_t2;
          sw_t3 <=sw_t3;
        end
    end
    //3Alm
    always@(posedge clk,posedge reset) 
      if(reset==1'b1)
         sw_value <= 1'b0;
      else
        if(check_sig==1'b1)
          if((sw_t1==1'b0)&&(sw_t2==1'b0)&&(sw_t3==1'b0))
            sw_value <= 1'b0;
          else if((sw_t1==1'b1)&&(sw_t2==1'b1)&&(sw_t3==1'b1))
            sw_value <= 1'b1;
          else
            sw_value <= sw_value;
        else
          sw_value <= sw_value;
        
    assign sw_out = sw_value;
endmodule
